<?php

/* 

	sets repository to local and farm skin subdirectories, and farmpuburl subdirectory

	then clones the repository, once for styles, once for scripts so that these elements can be searched separately

	

	repository

		styles

		scripts

		

	API

	set_repository($repostory)

	get_repository()

	assemble_addin() // generates style and script addin components for template, subclass can add additional elements

*/

abstract class PageAddin

{

	private $_repository;

	protected $_foldername;

	protected $_pageframework;

	

	public function __construct()

	{

		if (!$this->_foldername)

		{

			$this->_foldername = strtolower(get_class($this));

		}

		$this->_repository = $repository = new Repository();



		$this->_pageframework = $pageframework = PageFrameworks::instance()->get_selected_framework();

		$pagerepository = $pageframework->get_repository();

		$skinrepository = $pagerepository->get_repository('skinrepository');

		$locationindexes = $skinrepository->find_all_location_indexes($this->_foldername);

		$locations = array();

		$urls = array();

		foreach ($locationindexes as $index)

		{

			$locations[] = $skinrepository->get_location($index) . '/' . $this->_foldername;

			$urls[] = $skinrepository->get_url($index) . '/' . $this->_foldername;

		}

		$repository->set_location($locations);

		$repository->set_url($urls);



		$objectwiki = ObjectWiki::instance();

		$farmpublicresource = 

			$objectwiki

				->get_repository()

				->get_repository('publicresources')

				->get_resource('farmpublic');

		

		if (file_exists($farmpublicresource['location'] . '/' . $this->_foldername))

		{

			$repository->set_resource(

				$farmpublicresource['location'] . '/' . $this->_foldername,

				$farmpublicresource['url'] . '/' . $this->_foldername);

		}

		$stylesclone = clone $repository;

		$scriptsclone = clone $repository;

		$repository->set_repository('styles',$stylesclone);

		$repository->set_repository('scripts',$scriptsclone);

	}

	

	public function assemble_addin()

	{

		// generate style and script references in template

		$stylesrepository = $this->get_repository()->get_repository('styles');

		$stylesurls = $stylesrepository->get_fileurls();

		foreach($stylesurls as $filespec) 

		{
			$this->_pageframework->add_header_component

				("<link rel='stylesheet' type='text/css' href='$filespec' />\n");

		}

		$scriptsrepository = $this->get_repository()->get_repository('scripts');

		$scriptsurls = $scriptsrepository->get_fileurls();

		foreach($scriptsurls as $filespec) 

		{
			$this->_pageframework->add_header_component

				("<script type='text/javascript' src='$filespec'></script>\n");

		}

	}



	public function set_repository($repository)

	{

		$this->_repository = $repository;

	}

	public function get_repository()

	{

		return $this->_repository;

	}

	public function get_pageframework()

	{

		return $this->_pageframework;

	}

}