<?php

/*

	repository

		skinrepository

		skinselection

			(resource) skinselection

*/

abstract class PageFramework

{

	const DEFAULT_ACTION = "browse";

	

	protected $_actionskins = array();

	protected $_addins = array();

	protected $_repository;

	protected $_selected_skin;



	// sets pmwiki's HTMLHeaderFmt, and any custom variables

	// knows about 'style' and 'script' named repositories

	public function assemble_addins()

	{

		$addins = $this->_addins;

		foreach ($addins as $addin)

		{

			$addin->assemble_addin();

		}

	}



	//$skin_name must be a value or an associative array

	public function set_action_skin($skin_name,$action_name = NULL)

	{

		if (is_null($action_name))

		{

			if (is_array($skin_name))

			{

				$this->_actionskins = array_merge($this->_actionskins,$skin_name);

			}

			else

			{

				$this->_actionskins[PageFramework::DEFAULT_ACTION] = $skin_name;

			}

		}

		else

		{

			$this->_actionskins[$action_name] = $skin_name;

		}

		PMW_Skins::instance()->set_action_skin($skin_name,$action_name);

	}

	

	// $addin is a list array of PageAddin classnames:

	// to override a class, use an association: array('overrideclass'=>'myclass')

	// The addins provide lists of scripts, styles

	// uses pubdir (and url), farmpubdir (and url), $farmskindir (and url), skindir (and url)

	public function set_addin($addin)

	{

		$addins = (array) $addin;

		foreach ($addins as $key => $addinclass)

		{

			if (!is_string($key))

			{

				$key = $addinclass;

			}

			$object = new $addinclass();

			$this->_addins[$key] = $object;

		}

	}

	public function get_addin($addin)

	{

		if (array_key_exists($addin,$this->_addins))

		{

			return $this->_addins[$addin];

		}

		else

		{

			return NULL;

		}

	}

	

	public function get_repository()

	{

		return $this->_repository;

	}

	

	public function prepare_framework()

	{

		$pmwiki_skins = PMW_Skins::instance();

		$this->_selected_skin = $pmwiki_skins->get_skin();

		

		$this->_repository = $repository = new Repository();



		$skinrepository = new Repository();

		$skindirs = $pmwiki_skins->get_skin_dirs();

		$skinurls = $pmwiki_skins->get_skin_urls();

		$skinrepository->set_location($skindirs);

		$skinrepository->set_url($skinurls);

		$repository->set_repository('skinrepository',$skinrepository);

		

		$skinselection = new Repository();

		$skinselection->set_resource

			(

				$pmwiki_skins->get_skin_dir(),

				$pmwiki_skins->get_skin_url(),

				'skinselection'

			);

		$repository->set_repository('skinselection',$skinselection);

		

		$this->assemble_addins();

	}

	public function add_header_component($component, $index = NULL)

	{

		PMW_Skins::instance()->add_header_component($component,$index);

	}

}